//In case another mod wants to hook on and utilize the save and load functions
$Swol::EnvGuiSaverVersion = 2;

package swol_EnvGuiSaver
{
	function serverCmdEnvGui_SetVar(%object,%var,%value)
	{
		parent::serverCmdEnvGui_SetVar(%object,%var,%value);
		cancel($Swol::saveEnvGuiSched);
		//wait a little while so that we're not constantly saving every time someone changes a variable
		$Swol::saveEnvGuiSched = schedule(8000,0,saveEnvironment,"config/server/savedEnvironment.txt");
	}
	function GameConnection::autoAdminCheck(%cl)
	{
		if(!$Swol::EnvGuiSaverFirstConnectCheck)
		{
			$Swol::EnvGuiSaverFirstConnectCheck = 1;
			if(isFile("config/server/savedEnvironment.txt"))
			swol_loadEnvGui("config/server/savedEnvironment.txt");
		}
		return parent::autoAdminCheck(%cl);
	}
	function endMission()
	{
		//I don't even know if this is a server function but I'm assuming if a dedicated server gets restarted it will have reset everything
		$Swol::EnvGuiSaverFirstConnectCheck = 0;
		return parent::endMission();
	}
	function swol_loadEnvGui(%file)
	{
		%res = GameModeGuiServer::ParseGameModeFile(%file, 1);
				
		EnvGuiServer::getIdxFromFilenames();
		EnvGuiServer::SetSimpleMode();

		if(!$EnvGuiServer::SimpleMode)     
		{
			EnvGuiServer::fillAdvancedVarsFromSimple();
			EnvGuiServer::SetAdvancedMode();
		}
	}
};
ActivatePackage(swol_EnvGuiSaver);